<script src="/libs/codemirror/addon/mode/overlay.js"></script>
<script src="/libs/codemirror/mode/markdown/markdown.js"></script>
<script src="/libs/codemirror/mode/gfm/gfm.js"></script>
<!-- <script src="/libs/codemirror/mode/sql/sql.js"></script>
<script src="/libs/codemirror/mode/clike/clike.js"></script> -->
<script src="/libs/codemirror/mode/javascript/javascript.js"></script>
<script>

  const markedRenderer = new marked.Marked(
    markedHighlight.markedHighlight({
      langPrefix: 'hljs language-',
      highlight(code, lang) {
        if ( ['nohighlight', 'plaintext'].includes(('' + lang).trim())) {
          return code;
        } else {
          const language = hljs.getLanguage(lang);
          if (typeof language === 'undefined') {
            return hljs.highlightAuto(code).value;
          } else {
            return hljs.highlight(code, { language: language.name, ignoreIllegals: true }).value;
          }
        }
      }
    })
  );
  $('.custom-file-input').on('change', function () {
    let fileName = $(this).val().split('\\').pop();
    $(this).next('.custom-file-label').addClass("selected").html(fileName);
  });


  var dataObjectEditor;
  $("textarea[data-a2-type='data-object']").each(function (idx, elem) {
    dataObjectEditor = CodeMirror.fromTextArea(elem, {
      mode: 'text/javascript',
      lineNumbers: true,
      theme: "<%= session.cmSkin %>",
      styleActiveLine: true,
      matchBrackets: true,
      gutter: true,
      lineWrapping: true,
      viewportMargin: Infinity
    });
  });
  var evalScriptEditor;
  $("textarea[data-a2-type='eval-script']").each(function (idx, elem) {
    evalScriptEditor = CodeMirror.fromTextArea(elem, {
      mode: 'text/javascript',
      lineNumbers: true,
      theme: "<%= session.cmSkin %>",
      styleActiveLine: true,
      matchBrackets: true,
      gutter: true,
      lineWrapping: true,
      viewportMargin: Infinity
    });
  });

  var codeEditors = [];
  $("textarea[data-a2-type='code']").each(function (idx, elem) {
    codeEditors.push(CodeMirror.fromTextArea(elem, {
      mode: 'gfm',
      lineNumbers: true,
      theme: "<%= session.cmSkin %>",
      styleActiveLine: true,
      matchBrackets: true,
      gutter: true,
      lineWrapping: true,
      viewportMargin: Infinity
    }));
  });
  var sqlEditors = [];
  $("textarea[data-a2-type='sqlcode']").each(function (idx, elem) {
    sqlEditors.push(CodeMirror.fromTextArea(elem, {
      lineNumbers: true,
      indentUnit: 4,
      tabSize: 4,
      lineWrapping: true,
      mode: "text/x-pgsql",
      theme: "<%= session.cmSkin %>",
      readOnly: false,
      viewportMargin: Infinity
    }));
  });
  var cEditors = [];
  $("textarea[data-a2-type='ccode']").each(function (idx, elem) {
    cEditors.push(CodeMirror.fromTextArea(elem, {
      lineNumbers: true,
      indentUnit: 3,
      tabSize: 3,
      lineWrapping: true,
      mode: "text/x-csrc",
      theme: "<%= session.cmSkin %>",
      readOnly: false,
      viewportMargin: Infinity,
      <% if (locals.google_translate_key) { %>
      extraKeys: {
                "Ctrl-Enter": async function(cm) {
                    let txt = cm.getSelection();
                    if (!txt || 0 == txt.length) {
                      alert("Select something");
                    } else {
                      let translated = await translateHr2En(txt);
                      if (translated) {
                        let from = cm.getCursor("from");
                        let to = cm.getCursor("to");
                        cm.replaceRange(translated, from, to);
                      }
                    }
                }
            }
      <% } %>
    }));
  });

  var textEditors = [];
  $("textarea[data-a2-type='text']").each(function (idx, elem) {
    textEditors.push(CodeMirror.fromTextArea(elem, {
      lineNumbers: true,
      indentUnit: 4,
      tabSize: 4,
      lineWrapping: true,
      mode: "text",
      theme: "<%= session.cmSkin %>",
      readOnly: false,
      viewportMargin: Infinity,
    }));
  });
  var mdTextEditors = [];
  $("textarea[data-a2-type='mdtext']").each(function (idx, elem) {
    mdTextEditors.push(CodeMirror.fromTextArea(elem, {
      lineNumbers: true,
      indentUnit: 4,
      tabSize: 4,
      lineWrapping: true,
      mode: "text",
      theme: "<%= session.cmSkin %>",
      readOnly: false,
      viewportMargin: Infinity,
       <% if (locals.google_translate_key) { %>
      extraKeys: {
                "Ctrl-Enter": async function(cm) {
                    let txt = cm.getSelection();
                    if (!txt || 0 == txt.length) {
                      alert("Select something");
                    } else {
                      let translated = await translateHr2En(txt);
                      if (translated) {
                        let from = cm.getCursor("from");
                        let to = cm.getCursor("to");
                        cm.replaceRange(translated, from, to);
                      }
                    }
                }
            }
      <% } %>
    }));
  });
  <% if (locals.google_translate_key) { %>
    async function translateHr2En(txt) {
        let body = {
          q: [txt],
          format: "text",
          source: "hr",
          target: "en"
        };

        let response = await fetch('https://translation.googleapis.com/language/translate/v2?key=<%-locals.google_translate_key%>', {
                method: 'post',
                body:    JSON.stringify(body),
                headers: { 'Content-Type': 'application/json' },
            });
        if (response.ok) { // if HTTP-status is 200-299
          let res = await response.json();
          console.log(res);
          if (res.error) {
            alert (res.error.message);
            return undefined;
          } else {
            let text = res.data.translations[0].translatedText;
            text = text.replace("&#39;", "'");
            text = text.replace("&quot;", '"');
            return text;
          }
        } else {
          alert("HTTP-Error: " + response.status);
        }
    }
  <% } %>


  var jsEditors = [];
  $("textarea[data-a2-type='jsoncode']").each(function (idx, elem) {
    jsEditors.push(CodeMirror.fromTextArea(elem, {
      lineNumbers: true,
      indentUnit: 4,
      tabSize: 4,
      lineWrapping: true,
      mode: "text/javascript",
      theme: "<%= session.cmSkin %>",
      readOnly: false,
      viewportMargin: Infinity
    }));
  });

  CodeMirror.on(window, "hashchange", function () {
    var theme = location.hash.slice(1);
    if (theme) {
      input.value = theme;
      selectTheme();
    }
  });
  var refreshPreviews = function () {
    $("div[data-a2-type='preview']").each(async function (idx, elem) {
      var e = $(elem);
      let md = $("#" + e.attr("data-a2-src")).val();
      md = await edgar.injectSvgDiagrams(md);
      var html = markedRenderer.parse(md);
      html = html.replace(new RegExp('%img_folder_placeholder%', 'g'), '/images/qs');
      e.html(html.replace(new RegExp('%tuts_img_folder_placeholder%', 'g'), '/images/tutorials'));
    });
  };
  refreshPreviews();
  mdTextEditors.forEach(function (ed) {
    ed.on('change', async (editor) => {
      let md = editor.getDoc().getValue();
      md = await edgar.injectSvgDiagrams(md);
      var html = markedRenderer.parse(md)
        .replace(new RegExp('%img_folder_placeholder%', 'g'), '/images/qs')
        .replace(new RegExp('%tuts_img_folder_placeholder%', 'g'), '/images/tutorials');
      $("div[data-a2-src='" + $(ed.getTextArea()).attr("id") + "']").html(html);
    });
  });
  const insertMarkup = (markup) => {
        const editor = mdTextEditors[0];
        if (editor) {
            let curr = editor.getCursor();
            if (curr) {
                editor.replaceRange(markup, curr);
            } else {
                editor.replaceRange(markup, CodeMirror.Pos(editor.lastLine()));
            }
            editor.save();
        }
    };


    $("#btnInsertDiagram").click(function (e) {
        var btn = $(this);
        e.preventDefault();
        const markup = `
This is an inline diagram:
<!-- inline-diagram -->
sequenceDiagram
    Alice->>John: Hello John, how are you?
    John-->>Alice: Great!
    Alice-)John: See you later!
<!-- /inline-diagram -->

This is centered diagram:
<!-- diagram -->
graph
7-->3
7-->12
3-->2
3-->5,6
<!-- /diagram -->
`;
        insertMarkup(markup);
    });

  $("#runAllC").hover(
    function () {
      $(this).append($("<span><br> --- Be sure to save (except code-main) before running this! ---</span><br>"));
    },
    function () {
      $(this).find("span:last").remove();
    }
  );
  $('.randGenType').change(function () {
    var low = "#" + $(this).attr("targetlow");
    var up = "#" + $(this).attr("targetup");
    var nmb = "#" + $(this).attr("targetnmb");
    if ($(this).val() == '1' || $(this).val() == '2') {
      $(low).show();
      $(up).show();
      $(nmb).show();
    } else if ($(this).val() == '3' || $(this).val() == '4') {
      $(low).hide();
      $(up).hide();
      $(nmb).show();
    } else {
      $(low).show();
      $(up).show();
      $(nmb).hide();
    }
  });
  $(".preview-btn").click(function (e) {
    var btn = $(this);
    e.preventDefault(); // prevents default
    if (btn.attr("left") === '0') {
      $("#preview-left").attr('class', 'd-none');
    } else {
      $("#preview-left").attr('class', 'col-' + btn.attr("left"));
    }
    if (btn.attr("right") === '0') {
      $("#preview-right").attr('class', 'd-none');
    } else {
      $("#preview-right").attr('class', 'col-' + btn.attr("right"));
    }
    return false; // also prvents default (i like to add both but just the e.preventDefault is required :) )
  });
  // const SEPARATOR = "\n  ";
  $("#btnRenderTemplate").click(function (e) {
    var btn = $(this);
    var txts = [];
    var ids = [];
    mdTextEditors.forEach(function (ed) {
      txts.push(ed.getDoc().getValue());
      ids.push($(ed.getTextArea()).attr("id"));
    });
    $.ajax({
        url: "/question/rendertemplate/" + btn.attr("id_question"),
        type: "POST",
        cache: false,
        data: {
          templates: txts,
          data_object: dataObjectEditor.getValue()
        },
        success: function (data, status) {
          let htmls = data.data.htmls;
          for (i = 0; i < htmls.length; ++i) {
            $("div[data-a2-src='" + ids[i] + "']").html(htmls[i]);
          }
          console.log("Log", data.data.log);
          console.log("Data object", data.data.data_object);
        },
        error: function (xhr, desc, err) {
          alert('' + desc + ' err:' + err);
        }
      });
  });
  $("#btnEvaluateScript").click(function (e) {
    var btn = $(this);
    e.preventDefault();
    $("#evaluated-eval-script").html("Evaluating, please wait...");
    cEditors.forEach(function (editor) {
      editor.save();
    });
    evalScriptEditor.save();
    var code = '';  // TODO: dedup this code
    if (btn.attr("target").indexOf(',') > 0) {
      var targets = btn.attr("target").split(',');
      targets.forEach(function (id) {
        let item = $("#" + id.trim()).val();
        if (item) code += '\n' + item + '\n';
      });
    } else {
        code = $("#" + btn.attr("target")).val();
    }
    $.ajax({
        url: "/question/evalscript/" + btn.attr("id_question"),
        type: "POST",
        cache: false,
        data: {
          code,
          script: evalScriptEditor.getValue(),
          id_script_programming_language: $('#id_script_programming_language').val(),
          id_programming_language: $('#question-answer-programming-language').val(),
          freetextanswer: $("#dummyfreetextanswer").val()
        },
        success: function (data, status) {
          if (data.data.score) {
            $("#evaluated-eval-script").html(
              "<PRE>Score is:\n" + JSON.stringify(data.data.score, null, 2) + "</PRE>"
                + "<details><summary>Click to see the entire object...</summary>"
                + "<PRE>" + JSON.stringify(data.data, null, 2) + "</PRE></details>"
                );

          } else {
            $("#evaluated-eval-script").html(
              "<PRE>Warning: SCORE MISSING!\n" + JSON.stringify(data.data, null, 2) + "</PRE>");
          }

        },
        error: function (xhr, desc, err) {
          alert('' + desc + ' err:' + err);
        }
      });
  });
  $("#btnSsRender").click(function (e) {
    var btn = $(this);
    var txts = {};
    mdTextEditors.forEach(function (ed) {
      txts[$(ed.getTextArea()).attr("id")] = ed.getDoc().getValue();
    });
    $("div[data-a2-type='preview']").each(function (idx, elem) {
      var e = $(elem);
      var txt = txts[e.attr("data-a2-src")];
      $.ajax({
        url: "/question/md2html",
        type: "POST",
        cache: false,
        data: {
          md: txt
        },
        success: function (data, status) {
          e.html(data.html);
        },
        error: function (xhr, desc, err) {
          e.html('' + desc + ' err:' + err);
        }
      });
    });
  });


  $("button[name='runsql']").click(function (e) {
    var btn = $(this);
    e.preventDefault(); // prevents default
    sqlEditors.forEach(function (editor) {
      editor.save();
    });
    var sql = '';
    if (btn.attr("target").indexOf(',') > 0) {
      var targets = btn.attr("target").split(',');
      targets.forEach(function (id) {
        sql += '\n;\n' + $("#" + id.trim()).val() + '\n;\n';
      });
    } else {
      sql = $("#" + btn.attr("target")).val();
    }
    var data = {
      sql: sql
    };
    $.ajax({
      url: "/question/exec/" + btn.attr("id_question"),
      type: "POST",
      cache: false,
      data: data,
      success: function (data, status) {
        //var html = 'SQL executed:<PRE>' + data.sql2exec.replace('\n', '<BR/>') + '</PRE>';
        var html = data.success ? edgar.json2Table(data.data) : data.error.message + '(Position:' + data.error.position + ')';
        $("#" + btn.attr("resultdiv")).html(html);
      },
      error: function (xhr, desc, err) {
        $("#" + btn.attr("resultdiv")).html('' + data);
      }
    });
    return false;
  });
  $("button[name='runjson']").click(function (e) {
    var btn = $(this);
    e.preventDefault(); // prevents default
    $("#" + btn.attr("resultdiv")).html('Running query, please wait...');
    jsEditors.forEach(function (editor) {
      editor.save();
    });
    var js = '';
    if (btn.attr("target").indexOf(',') > 0) {
      var targets = btn.attr("target").split(',');
      targets.forEach(function (id) {
        js += '\n\n' + $("#" + id.trim()).val() + '\n;\n';
      });
    } else {
      js = $("#" + btn.attr("target")).val();
    }
    var data = {
      js: js
    };
    $.ajax({
      url: "/question/exec/" + btn.attr("id_question"),
      type: "POST",
      cache: false,
      data: data,
      success: function (data, status) {
        var html = data.success ? '<PRE>' + JSON.stringify(data.data, null, 2) + '</PRE>' : data.error.message + '(Position:' + data.error.position + ')';
        $("#" + btn.attr("resultdiv")).html(html);
      },
      error: function (xhr, desc, err) {
        $("#" + btn.attr("resultdiv")).html('' + data);
      }
    });
    return false;
  });
  $("#btnEvalDataObject").click(function (e) {
    var btn = $(this);
    e.preventDefault(); // prevents default
    $("#evaluated-data-object").html('Evaluating, please wait...');
    $("#evaluated-data-object-log").html('Evaluating, please wait...');
    dataObjectEditor.save();

    var data = {
      data_object: dataObjectEditor.getValue()
    };
    $.ajax({
      url: "/question/evaldo/",
      type: "POST",
      cache: false,
      data: data,
      success: function (data, status) {
        if (data.success) {
          $("#evaluated-data-object").html('<PRE>' + data.data.data_object + '</PRE>');
          $("#evaluated-data-object-log").html('<PRE style="font-size: 8px;">Log:\n' + data.data.log + '</PRE>');
        } else {
          $("#evaluated-data-object").html('<PRE>' + data.error.message + '</PRE>');
          $("#evaluated-data-object-log").html('');
        }
      },
      error: function (xhr, desc, err) {
        $("#evaluated-data-object").html('' + err);
        $("#evaluated-data-object-log").html("");
      }
    });
    return false;
  });


  $(".chosen-select").chosen();

  $("button[name='tryRand']").click(function (e) {
    var btn = $(this);
    e.preventDefault(); // prevents default

    btn.html('<i class="fa fa-2 fa-spinner fa-spin"></i>');
    btn.prop("disabled", true);

    cEditors.forEach(function (editor) {
      editor.save();
    });

    var randType = $("#" + btn.attr("randType")).val();
    console.log("randType: " + randType);
    var low = $("#" + btn.attr("low")).val();
    console.log("low: " + low);
    var up = $("#" + btn.attr("up")).val();
    console.log("up: " + up);
    var count = $("#" + btn.attr("count")).val();
    console.log("count: " + count);

    var lowLength = low.trim().length;
    var upLength = up.trim().length;
    var countLength = count.trim().length;

    switch (randType) {
      case "1":
      case "2":
        if (lowLength == 0 || upLength == 0 || countLength == 0) {
          $("#" + btn.attr("resultdiv")).html('<div class="alert alert-warning">Low bound, upper bound and number of elements must be defined.</div>');
          btn.html('Try generator');
          btn.prop("disabled", false);
          return false;
        }
        break;
      case "3":
      case "4":
        if (countLength == 0) {
          $("#" + btn.attr("resultdiv")).html('<div class="alert alert-warning">Number of elements must be defined.</div>');
          btn.html('Try generator');
          btn.prop("disabled", false);
          return false;
        }
        break;
      case "5":
      case "6":
        if (lowLength == 0 || upLength == 0) {
          $("#" + btn.attr("resultdiv")).html('<div class="alert alert-warning">Low bound and upper bound must be defined.</div>');
          btn.html('Try generator');
          btn.prop("disabled", false);
          return false;
        }
        break;
      default:
        $("#" + btn.attr("resultdiv")).html('<div class="alert alert-warning">Select value type generator.</div>');
        btn.html('Try generator');
        btn.prop("disabled", false);
        return false;
    }

    var data = {
      config: {
        randType: randType,
        low: low,
        up: up,
        count: count
      }
    };
    $.ajax({
      url: "/question/trygenerator",
      type: "POST",
      cache: false,
      data: data,
      success: function (data, status) {
        //var html = 'SQL executed:<PRE>' + data.sql2exec.replace('\n', '<BR/>') + '</PRE>';
        // console.log("success response ");
        // console.log("data: " + data);
        // console.log("status: " + status);
        $("#" + btn.attr("resultdiv")).html('<hr>' + data.inputs);
        btn.html('Try generator');
        btn.prop("disabled", false);
      },
      error: function (xhr, desc, err) {
        console.log("error response ");
        console.log("err: " + err);
        console.log("desc: " + desc);
        $("#" + btn.attr("resultdiv")).html('' + data);
        btn.html('Try generator');
        btn.prop("disabled", false);
      }
    });
    return false;
  });

  $(".remove").click(function (e) {
    var btn = $(this);
    e.preventDefault();

    edgar.showConfirmDialog("Are you sure you want to delete this test-case?", function () {
      var cQuestionTestId = btn.attr("cQuestionTestId");
      $.ajax({
        url: "/question/ctest/delete/" + cQuestionTestId,
        type: "POST",
        cache: false,
        //data: data,
        success: function (data, status) {
          console.log("success response: ", data);
          if (data.success) {
            $("#" + btn.attr("target")).remove();
            edgar.showInfoDialog("Test removed");
          } else {
            edgar.showInfoDialog("Error removing test: " + data.error.message);
          }
        },
        error: function (xhr, desc, err) {
          edgar.showInfoDialog("Error removing test: " + desc);
        }
      });
    });
    return false;
  });

  $(".id_test_type").click(function (e) {
    var btn = $(this);
    //var val = btn.val();

    $(".sql_result").html('');

    if (btn.attr("targetshow").indexOf(',') > 0) {
      var targets = btn.attr("targetshow").split(',');
      targets.forEach(function (id) {
        $("." + id.trim()).show();
      });
    } else {
      $("." + btn.attr("targetshow")).show();
    }

    if (btn.attr("targethide").indexOf(',') > 0) {
      var targets = btn.attr("targethide").split(',');
      targets.forEach(function (id) {
        $("." + id.trim()).hide();
      });
    } else {
      $("." + btn.attr("targethide")).hide();
    }

    cEditors.forEach(editor => {
      editor.refresh();
    });

  });

  $('[edgar-user-prop="1"]').on('change click', function () {
    var value;
    if ($(this).prop('checked') !== undefined) {
      value = $(this).prop('checked');
    } else {
      value = $(this).hasClass("collapsed");
    }
    $.ajax({
      url: "/prefs/save/" + $(this).prop('name'),
      type: "POST",
      cache: false,
      data: {
        value: value
      },
      success: function (data, status) {
        console.log('success', data);
      },
      error: function (xhr, desc, err) {
        console.log('error', desc, err);
      }
    });
    return true;
  });

  function escapeRegExp(string) {
    return string.replace(/[.*+?^${}()|[\]\\]/g, '\\$&'); // $& means the whole matched string
  }

  var markWhitespace = function (html) {
    html = html.replace(/\r\n/g, '\n');
    var newhtml = html;
    html.match(/<pre>((.|\n|\r)*?)<\/pre>/g).map(function (val) {
      newhtml = newhtml.replace(new RegExp(escapeRegExp(val), 'g'), val.replace(/ /g, '·').replace(/\n/g, '↵\n'));
    });
    return newhtml;
  };
  $("button[name='runcAll']").click(function (e) {
    var btn = $(this);
    e.preventDefault(); // prevents default

    btn.html('<i class="fa fa-2 fa-spinner fa-spin"></i>');
    btn.prop("disabled", true);
    $("#" + btn.attr("resultdiv")).html('<div class="row text-center"><i class="fa fa-2 fa-spinner fa-spin" style="font-size:92px"></i></div>');

    cEditors.forEach(function (editor) {
      editor.save();
    });

    var c = '';
    if (btn.attr("target").indexOf(',') > 0) {
      var targets = btn.attr("target").split(',');
      targets.forEach(function (id) {
        c += '\n' + $("#" + id.trim()).val() + '\n';
      });
    } else {
      c = $("#" + btn.attr("target")).val();
    }

    if (c.trim().length == 0) {
      $("#" + btn.attr("resultdiv")).html('<div class="alert alert-warning">There is no code to execute.</div>');
      btn.html('Run all test-cases');
      btn.prop("disabled", false);
      return false;
    }

    let id_programming_language = $('#question-answer-programming-language').val();

    var data = {
      isCtype: true,
      source: c,
      config: {
        all: true
      },
      id_programming_language
    };
    $.ajax({
      url: "/question/exec/" + btn.attr("id_question"),
      type: "POST",
      cache: false,
      data: data,
      success: function (data, status) {
        if ($('#chkMarkWhitespace').prop('checked')) data.data = markWhitespace(data.data);
        $("#" + btn.attr("resultdiv")).html(data.success ? data.data : `<div class="alert alert-danger">${data.error.message}</div>`);
        btn.html('Run all test-cases');
        btn.prop("disabled", false);
      },
      error: function (xhr, desc, err) {
        $("#" + btn.attr("resultdiv")).html('' + data);
        btn.html('Run all test-cases');
        btn.prop("disabled", false);
      }
    });
    return false;
  });


  $('.btn-test-regex').click(function () {
    var value = $(this).parent().parent().find('.input-regex').val();
    var regex = new RegExp($('#test_regex_input').val(), 'g');
    var result = regex.test(value);

    if (result) {
      $(this).removeClass('btn-success');
      $(this).addClass('btn-success');
    } else {
      $(this).removeClass('btn-danger');
      $(this).addClass('btn-danger');
    }
  });

  function removeAttachment(e) {
    let filename = e.target.id.split('-').pop();

    $.ajax({
      url: "/upload/attachment/" + filename,
      type: "DELETE",
      cache: false,
      success: function (result, status, xhr) {
        $(`#${e.target.id}`).parent().hide('slow', () => {
          $(`#${e.target.id}`).parent().remove();
        });
      },
      error: function (xhr, status, error) {
        console.log('status: ' + JSON.stringify(status, null, 4));
        console.log('error: ' + JSON.stringify(error, null, 4));
      }
    });
  }

  $('.remove-attachment').click(removeAttachment);

  const titles = {
    true: 'Public test case',
    false: 'Private test case'
  };

  function toggleTestcaseVisiblity(button, testId) {
    $(button).find('i').toggleClass('fas fa-eye fas fa-eye-slash');

    let checked = $(`#id_test_case_${testId}`).prop('checked');
    $(`#id_test_case_${testId}`).prop('checked', !checked);

    $(button).find('i').attr('title', titles[!checked]);
  }

  let $uploadButton = $('#upload-attachment');
  $uploadButton.click(e => {
    $uploadButton.html('Uploading...');
    $uploadButton.prop("disabled", true);

    let $attachment = $('#attachment');
    let isPublic = $('#is_attachment_public').prop('checked');
    let attachment_label = $('#attachment_label').val();
    let id_question = $uploadButton.attr("id_question");

    let attachment = $attachment[0].files[0];

    let formData = new FormData();

    formData.append("attachment", attachment, attachment.name);
    formData.append("is_public", isPublic);
    formData.append("label", attachment_label);
    formData.append("id_question", id_question);

    $.ajax({
      url: "/upload/attachment/",
      type: "POST",
      enctype: "multipart/form-data",
      cache: false,
      data: formData,
      processData: false,
      contentType: false,
      success: function (result, status, xhr) {
        // $("#" + $uploadButton.attr("resultdiv")).html(data.success ? data.data : `<div class="alert alert-danger">${data.error.message}</div>`);
        $('#attachments-panel').append(`
                        <div class="col-12 resultitem resultitemFile d-flex justify-content-start">
                            <div>
                                <a href="/upload/attachment/${result.filename}" target="_blank" class="files visible ${result.isPublic === "true" ? 'publicatt' : 'privateatt'}" download>
                                    <div class="icon-pos"><i class="file-icon fa fa-file"></i></div>
                                </a>
                            </div>
                            <div class="file-info">
                              <div class="file_name" style="display: table-cell"><span
                                  class="name">${result.label}</span></div>
                              <div class="file_size"><span class="details">
                                </span> </div>
                            </div>
                            <div class="ml-3">
                              ${result.isPublic === "true" ? 'PUBLIC' : 'private'}
                            </div>
                            <i id="delete-attachment-${result.filename}"
                               class="fas fa-times remove-attachment" style="margin-left: 5px">
                            </i>
                        </div>
                        `);
        $('.remove-attachment').last().click(removeAttachment);
        $uploadButton.html('Upload');
        $uploadButton.prop("disabled", false);
      },
      error: function (xhr, status, error) {
        console.log('error: ' + JSON.stringify(error, null, 4));
        $uploadButton.html('Upload');
        $uploadButton.prop("disabled", false);
      }
    });
  });

  $("#btnParseGraderObject").click((e) => {
    var btn = $(this);
    e.preventDefault(); // prevents default
    jsEditors.forEach(function (editor) {
      editor.save();
    });
    try {
      $("#graderObjectContainer").html('');
      $("#graderCommentPreview").val('');
        let graderObject = JSON.parse($("#grader_object").val());
        new edgar.Grader("graderObjectContainer", graderObject, "graderCommentPreview");
    } catch (e) {
        edgar.showInfoDialog('Invalid grader object, does not parse: ' + e.message);
    }

  });
  $("#btnGraderBoilerPlateAdd").click((e) => {
    var btn = $(this);
    e.preventDefault(); // prevents default
    if (jsEditors && jsEditors.length > 0) {
      let editor = jsEditors[jsEditors.length - 1];
      editor.setValue(`{
    "allCorrect": "All is correct, well done!",
    "intro": {
        "always": "Your task has been manually reviewed.",
        "error": "We found the following errors:"
    },
    "add": [
        {
            "perc": 50,
            "desc": "Has the first part"
        },
        {
            "perc": 50,
            "show": true,
            "desc": "Has the second part"
        }
    ],
    "outro": {
        "always": "Best regards",
        "error": "Due to the mentioned errors you should ..."
    }
}`);}
  });
  $("#btnGraderBoilerPlateDeduct").click((e) => {
    var btn = $(this);
    e.preventDefault(); // prevents default
    if (jsEditors && jsEditors.length > 0) {
      let editor = jsEditors[jsEditors.length - 1];
      editor.setValue(`{
    "allCorrect": "All is correct, well done!",
    "intro": {
        "always": "Your task has been manually reviewed.",
        "error": "We found the following errors:"
    },
    "deduct": [
        {
            "perc": 10,
            "desc": "Failed to properly address ..."
        },
        {
            "perc": 60,
            "desc": "Invalid major part."
        }
    ],
    "outro": {
        "always": "Best regards",
        "error": "Due to the mentioned errors you should ..."
    }
}`);}
  });
  $("#btnGraderBoilerPlateMixed").click((e) => {
    var btn = $(this);
    e.preventDefault(); // prevents default
    if (jsEditors && jsEditors.length > 0) {
      let editor = jsEditors[jsEditors.length - 1];
      editor.setValue(`{
    "allCorrect": "All is correct, well done!",
    "intro": {
        "always": "Your task has been manually reviewed.",
        "error": "We found the following errors:"
    },
    "add": [
        {
            "perc": 50,
            "desc": "Has the first part"
        },
        {
            "perc": 50,
            "show": true,
            "desc": "Has the second part"
        }
    ],
    "deduct": [
        {
            "perc": 10,
            "desc": "Failed to properly address ..."
        },
        {
            "perc": 60,
            "desc": "Invalid major part."
        }
    ],
    "outro": {
        "always": "Best regards",
        "error": "Due to the mentioned errors you should ..."
    }
}`);}
  });



</script>
